/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: TRG_DTULTATU_ENDFORN                                                    */
/*                                                                            */
/* Descrio:                                                                 */
/* Atualiza a data de ultima atualizao do Endereco do Fornecedor            */
/*                                                                            */
/* Criao:                                                                   */
/* 02/05/2000 - Yoris L. de Souza                                             */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ENDFORN'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER DTULTATU_ENDFORN
  GO

CREATE TRIGGER DTULTATU_ENDFORN
ON ENDEFORN
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'ENDEFORN', 'CDFORNECED=' + CDFORNECED + ';IDTPENDEFORN=' + IDTPENDEFORN+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ENDEFORN
      SET DTULTATUENFO = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ENDEFORN.DSENDEFORN,0)   = ISNULL(INSERTED.DSENDEFORN,0))  AND
            (ISNULL(ENDEFORN.NMBAIRFORN,0)   = ISNULL(INSERTED.NMBAIRFORN,0))  AND
            (ISNULL(ENDEFORN.NRCEPFORN,0)    = ISNULL(INSERTED.NRCEPFORN,0))   AND
            (ISNULL(ENDEFORN.NRTELEFORN,0)   = ISNULL(INSERTED.NRTELEFORN,0))  AND
            (ISNULL(ENDEFORN.SGESTADO,0)     = ISNULL(INSERTED.SGESTADO,0))    AND
            (ISNULL(ENDEFORN.NRFAXFORN,0)    = ISNULL(INSERTED.NRFAXFORN,0))   AND
            (ISNULL(ENDEFORN.CDPAIS,0)       = ISNULL(INSERTED.CDPAIS,0))      AND
            (ISNULL(ENDEFORN.CDMUNICIPIO,0)  = ISNULL(INSERTED.CDMUNICIPIO,0)) AND
            (ISNULL(ENDEFORN.IDTPENDEFORN,0) = ISNULL(INSERTED.IDTPENDEFORN,0)) AND
            (ISNULL(ENDEFORN.CDFORNECED,0)   = ISNULL(INSERTED.CDFORNECED,0));
   END;
END;
GO

